// Copyright (c) 2007, kafana.org
//
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are 
// permitted provided that the following conditions are met:
// 
// * Redistributions of source code must retain the above copyright notice, 
//   this list of conditions and the following disclaimer.
// * Redistributions in binary form must reproduce the above copyright notice, 
//   this list of conditions and the following disclaimer in the documentation and/or other 
//   materials provided with the distribution.
// * Neither the name of the kafana.org nor the names of its contributors may be used to 
//   endorse or promote products derived from this software without 
//   specific prior written permission. 
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

var gadgetSettings = new mcpuSettings();

function loadSettings()
{
    gadgetSettings.load();
    System.Gadget.onSettingsClosing = settingsClosing;
    
    document.getElementById('singleCpuBar').checked = gadgetSettings.showSingleCpuBar;
    selectCpuInterval();
}

function selectCpuInterval()
{
    var sel = document.getElementById('cpuReadInterval');
    for (var i = sel.length - 1; i >= 0; i--) {
        if (parseInt(sel.options[i].value) == gadgetSettings.cpuReadInterval) {
            sel.options[i].selected = true;
            break;
        }
    }
}

function settingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
        saveSettings();
    }
}

function mcpuSettings()
{   
    this.save = saveSettingToDisk;
    this.load = loadSettingFromDisk;
    
    this.showSingleCpuBar = false;
    this.cpuReadInterval = 1000;
    this.bootTimeReadInterval = 60000;
}

function loadSettingFromDisk()
{
    if (System.Gadget.Settings.read("SettingsExist"))
    {
        this.showSingleCpuBar = System.Gadget.Settings.read("showSingleCpuBar");
        this.cpuReadInterval = System.Gadget.Settings.read("cpuReadInterval");
        this.bootTimeReadInterval = System.Gadget.Settings.read("bootTimeReadInterval");
    }
}

function saveSettingToDisk()
{
    System.Gadget.Settings.write("SettingsExist", true);
    System.Gadget.Settings.write("showSingleCpuBar", this.showSingleCpuBar);
    System.Gadget.Settings.writeString("cpuReadInterval", this.cpuReadInterval);
    System.Gadget.Settings.writeString("bootTimeReadInterval", this.bootTimeReadInterval);
}

function saveSettings()
{
    gadgetSettings.showSingleCpuBar = document.getElementById('singleCpuBar').checked;
    gadgetSettings.cpuReadInterval = cpuReadInterval.options[cpuReadInterval.selectedIndex].value;
    gadgetSettings.bootTimeReadInterval = 60000;
    
    gadgetSettings.save();
}